import at
import qt

class MyApp(qt.QVBox):
    def __init__(self):
        qt.QVBox.__init__(self)
        grid = qt.QGrid(2,self)
        self.button1 = qt.QPushButton("Update table",grid)
        self.button2 = qt.QPushButton("Update tree",grid)
        self.gTable = at.TableEdit(grid)
        self.gTree = at.TreeEdit(grid)

        s = "(S (NP (N I)) (VP (VP (V saw) " \
            "(NP (DT the) (N man))) (PP (P with) " \
            "(NP (DT a) (N telescope)))))"

        self.tree = at.TreeModel.importTreebank([s]).next()
        self.table = self.tree.exportLPathTable(at.TableModel)

        self.gTree.setData(self.tree,[('label','Tree')])
        self.gTable.setData(self.table)

        self.connect(self.button1,qt.SIGNAL("clicked()"),self.updateTable)
        self.connect(self.button2,qt.SIGNAL("clicked()"),self.updateTree)

    def updateTable(self):
        self.table = self.tree.exportLPathTable(at.TableModel)
        self.gTable.setData(self.table)
        
    def updateTree(self):
        self.tree = at.TreeModel.importLPathTable(self.table)
        self.gTree.setData(self.tree,[('label','Tree')])
        
app = qt.QApplication([])
w = MyApp()
app.setMainWidget(w)
w.show()
app.exec_loop()
