from at import TreeModel, TreeEdit
import qt

class Demo(qt.QVBox):
    def __init__(self):
        qt.QVBox.__init__(self)
        self.button = qt.QPushButton('Reset',self)
        self.connect(self.button,qt.SIGNAL("clicked()"),self.load)
        self.button2 = qt.QPushButton(self)
        self.connect(self.button2,qt.SIGNAL("clicked()"),self.change)
        hbox = qt.QGrid(2, self)
        lbl1 = qt.QLabel("Edit Panel",hbox)
        lbl2 = qt.QLabel("Clipboard",hbox)
        lbl1.setMargin(2)
        lbl1.setAlignment(lbl1.AlignCenter)
        lbl2.setAlignment(lbl1.AlignCenter)
        self.treeview = TreeEdit(hbox)
        self.clipboard = TreeEdit(hbox)
        self.root = None
        self.load()
        self.resize(400,450)

    def load(self):
        from nltk_lite.parse import bracket_parse
        s = "(S (NP (N I)) (VP1 (VP2 (V saw) " \
            "(NP (ART the) (N man))) (PP (P with) " \
            "(NP (ART a) (N telescope)))))"
        t = bracket_parse(s)
        self.root = TreeModel.importNltkLiteTree(t)
        self.treeview.setData(self.root,[('label','Tree')])
        self.vp1 = self.root.children[1]
        self.pp = self.vp1.children[1]
        self.vp2 = self.vp1.children[0]
        self.stage = 0
        self.button2.setText('splice VP1')

    def change(self):
        if self.stage == 0:
            self.vp1.splice()
            self.clipboard.setData(self.vp1,[('label','Tree')])
            self.button2.setText('prune PP')
            self.stage = 1
        elif self.stage == 1:
            self.pp.prune()
            self.clipboard.setData(self.pp,[('label','Tree')])
            self.button2.setText('attach PP to VP2')
            self.stage = 2
        elif self.stage == 2:
            self.vp2.attach(self.pp)
            self.clipboard.setData(self.vp2,[('label','Tree')])
            self.button2.setText('')
            self.stage = 3

app = qt.QApplication([])
w = Demo()
app.setMainWidget(w)
w.show()
app.exec_loop()

